package com.gau.go.launcherex.theme.ssrizh;
import com.gau.go.launcherex.theme.ssrizh.R;


import java.util.Locale;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.ActivityNotFoundException;
import android.content.ComponentName;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnClickListener;
import android.content.DialogInterface.OnKeyListener;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.Toast;

/*
 * 点击功能表主题icon响应的activity
 */
public class NotificationActivity extends Activity {

	private boolean mApplyTheme = false;
	private ProgressDialog mProgressDialog = null;
	private AlertDialog mConfirmDialog = null;
	private AttachInfo mAi = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
	}

	@Override
	protected void onResume() {
		super.onResume();
		ThemeUtils.sendInactiveApplyThemeFlagBroadcast(this);
		mAi = MergeUtil.getAttachInfo(this);
		checkGoLauncher();
		mApplyTheme = false;
	}

	private void checkGoLauncher() {
		final Result result = GoLauncherUtils.isGoLauncherExist(this);
		boolean goLauncherExist = result.isExist;
		if (!goLauncherExist) {
			if (GoLauncherUtils.isGoLauncherUninstalled(this)) {
				displayGoLauncherUninstalledDialog();
			} else {
				//TODO: 如果Attach的是 apk包，这里等合并完成再显示下面的对话框
				displayInstallGoLauncherDialog();
			}

		} else {
			displayStartGoLauncherDialog(result);
		}
	}

	private void displayGoLauncherUninstalledDialog() {
		
	   String dialogtitle = null;
 	   String dialogmsg = null;
 	   String dialogreinstall = null;
 	   String dialoguninstall = null;
 	   
 	    String language = Locale.getDefault().getLanguage(); // zh
 	    if(language.equals("zh"))
 	    {
 	    	dialogtitle = "信息";
 	    	dialogmsg = "GO桌面已经被卸载，需要重新安装GO桌面或卸载本主题？";
 	    	dialogreinstall = "重新安装";
 	    	dialoguninstall = "卸载";
 	    }
 	    else
 	    {
 	    	dialogtitle = "Info";
 	    	dialogmsg = "GO Launcher EX has been uninstalled. Would you like to install it again or uninstall this theme?";
 	    	dialogreinstall = "Reinstall";
 	    	dialoguninstall = "Uninstall";
 	    }
 	    
		mConfirmDialog = new AlertDialog.Builder(this)
				.setTitle(dialogtitle)
				.setMessage(dialogmsg)
				.setPositiveButton(dialogreinstall,
						new OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								downloadGoLauncher();
								ThemeUtils
										.activeApplyThemeFlag(NotificationActivity.this);
								NotificationActivity.this.finish();
							}
						})
				.setNegativeButton(dialoguninstall,
						new OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								ThemeUtils.uninstall(NotificationActivity.this);
								NotificationActivity.this.finish();
							}
						}).setOnKeyListener(new OnKeyListener() {

					@Override
					public boolean onKey(DialogInterface dialog, int keyCode,
							KeyEvent event) {
						if (keyCode == KeyEvent.KEYCODE_BACK) {
							NotificationActivity.this.finish();
						}
						return false;
					}
				}).show();
	}

	private void displayInstallGoLauncherDialog() {
		
		   String dialogtitle = null;
	 	   String dialogmsg = null;
	 	   String dialogok = null;
	 	   String dialogcancel = null;
	 	   
	 	    String language = Locale.getDefault().getLanguage(); // zh
	 	    if(language.equals("zh"))
	 	    {
	 	    	dialogtitle = "信息";
	 	    	dialogmsg = "点击确定立刻安装桌面支持软件";
	 	    	dialogok = "确定";
	 	    	dialogcancel = "取消";
	 	    }
	 	    else
	 	    {
	 	    	dialogtitle = "Info";
	 	    	dialogmsg = "Press OK button to install GO Launcher EX";
	 	    	dialogok = "OK";
	 	    	dialogcancel = "Cancel";
	 	    }
	 	    
		mConfirmDialog = new AlertDialog.Builder(this)
				.setTitle(dialogtitle)
				.setMessage(dialogmsg)
				.setPositiveButton(dialogok, new OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) 
					{
						//TODO: 这里判断根据不同的attach执行不同的动作 
						downloadGoLauncher();
						ThemeUtils.activeApplyThemeFlag(NotificationActivity.this);
						NotificationActivity.this.finish();
					}
				})
				.setNegativeButton(dialogcancel,
						new OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								NotificationActivity.this.finish();
							}
						}).setOnKeyListener(new OnKeyListener() {

					@Override
					public boolean onKey(DialogInterface dialog, int keyCode,
							KeyEvent event) {
						if (keyCode == KeyEvent.KEYCODE_BACK) {
							NotificationActivity.this.finish();
						}
						return false;
					}
				}).show();
	}

	private void displayStartGoLauncherDialog(final Result result) {
		
		   String dialogtitle = null;
	 	   String dialogmsg = null;
	 	   String dialogok = null;
	 	   String dialogcancel = null;
	 	   
	 	    String language = Locale.getDefault().getLanguage(); // zh
	 	    if(language.equals("zh"))
	 	    {
	 	    	dialogtitle = "信息";
	 	    	dialogmsg = "点击确定立刻启用桌面支持软件";
	 	    	dialogok = "确定";
	 	    	dialogcancel = "取消";
	 	    }
	 	    else
	 	    {
	 	    	dialogtitle = "Info";
	 	    	dialogmsg = "Press OK button to launch GO Launcher EX";
	 	    	dialogok = "OK";
	 	    	dialogcancel = "Cancel";
	 	    }
	 	    
		mConfirmDialog = new AlertDialog.Builder(this)
				.setTitle(dialogtitle)
				.setMessage(dialogmsg)
				.setPositiveButton(dialogok, new OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// NotificationActivity.this.finish();
						startGoLauncher(
								result.packageName == null ? Constants.PACKAGE_LAUNCHER
										: result.packageName,
								result.componentName);
					}
				})
				.setNegativeButton(dialogcancel,
						new OnClickListener() {

							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								NotificationActivity.this.finish();
							}
						}).setOnKeyListener(new OnKeyListener() {

					@Override
					public boolean onKey(DialogInterface dialog, int keyCode,
							KeyEvent event) {
						if (keyCode == KeyEvent.KEYCODE_BACK) {
							NotificationActivity.this.finish();
						}
						return false;
					}
				}).show();
	}

	private void downloadGoLauncher() {
		
		if(mAi != null && mAi.IsGotoKTOllehMarket())
		{
			ThemeUtils.gotoKTOlleh_Market(this);
			return;
		}
		
	    if(mAi!= null && mAi.IsGotoKOOZ())
	    {
	    	ThemeUtils.gotoOZPID(this);
	    	return;
	    }
	    
	    if(mAi!= null && mAi.IsGotoKOTS())
	    {
	    	ThemeUtils.gotoKO_TS(this);
	    	return;
	    }
	    
	    if(mAi != null && mAi.mApkUrl != null)
		{
			GoLauncherUtils.downloadGoLauncher(this , mAi.mApkUrl);
			return;
		}
		
		GoLauncherUtils.downloadGoLauncher(this , Constants.DOWNLOAD_GOLAUNCHER_LINK);
	}

	private void startGoLauncher(final String packageName,
			final ComponentName componentName) {
		mApplyTheme = true;
		new AsyncTask<Void, Void, Boolean>() {

			@Override
			protected void onPreExecute() {
				String msg = null;
			 	   
		 	    String language = Locale.getDefault().getLanguage(); // zh
		 	    if(language.equals("zh"))
		 	    {
		 	    	msg = "GO桌面EX启用中，请稍后";
		 	    }
		 	    else
		 	    {
		 	    	msg = "Starting GO Launcher EX，please wait";
		 	    }
				
				mProgressDialog = ProgressDialog.show(
						NotificationActivity.this,
						null,
						msg, 
						true);
			}

			@Override
			protected Boolean doInBackground(Void... v) {
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				NotificationActivity.this.finish();
				try {
					GoLauncherUtils.startGoLauncher(NotificationActivity.this,
							packageName, componentName);
				} catch (Throwable e) {
					return false;
				}
				return true;
			}

			protected void onPostExecute(Boolean success) {
				if (mProgressDialog != null) {
					mProgressDialog.dismiss();
				}
				if (!success) {
					
					String msg = null;
				 	   
			 	    String language = Locale.getDefault().getLanguage(); // zh
			 	    if(language.equals("zh"))
			 	    {
			 	    	msg = "GO桌面启用失败，请重新安装GO桌面";
			 	    }
			 	    else
			 	    {
			 	    	msg = "Start GO Launcher EX failed, please reinstall GO Launcher EX";
			 	    }
			 	    
					Toast.makeText(
							NotificationActivity.this,
							msg, 
							Toast.LENGTH_LONG).show();
				}
			};
		}.execute();
	}

	@Override
	protected void onStop() {
		super.onStop();
		if (mApplyTheme) {
			mApplyTheme = false;
			ThemeUtils.sendApplyThemeBroadcast(this);
		}
	}

	@Override
	protected void onDestroy() {
		if (mProgressDialog != null) {
			mProgressDialog.dismiss();
			mProgressDialog = null;
		}
		if (mConfirmDialog != null) {
			mConfirmDialog.dismiss();
			mConfirmDialog = null;
		}
		super.onDestroy();
	}
}
