package com.gau.go.launcherex.theme.ssrizh;
import com.gau.go.launcherex.theme.ssrizh.R;


import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.net.Uri;
import android.widget.Toast;

public class ThemeUtils {
	public static final String NAME_THEME = "theme";
	public static final String KEY_APPLY_CURRENT_THEME = "apply_current_theme";
	public static final String KEY_EVER_USED = "ever_used";
	
	public static void activeApplyThemeFlag(Context context) {
		SharedPreferences sp = context.getSharedPreferences(NAME_THEME,
				Context.MODE_PRIVATE);
		Editor editor = sp.edit();
		editor.putBoolean(KEY_APPLY_CURRENT_THEME, true);
		editor.commit();
	}

	public static void inactiveApplyThemeFlag(Context context) {
		SharedPreferences sp = context.getSharedPreferences(NAME_THEME,
				Context.MODE_PRIVATE);
		Editor editor = sp.edit();
		editor.putBoolean(KEY_APPLY_CURRENT_THEME, false);
		editor.commit();
	}

	public static boolean getApplyThemeFlag(Context context) {
		SharedPreferences sp = context.getSharedPreferences(NAME_THEME,
				Context.MODE_PRIVATE);
		return sp.getBoolean(KEY_APPLY_CURRENT_THEME, false);
	}

	public static void sendApplyThemeBroadcast(Context context) {
		Intent intent = new Intent(Constants.ACTION_MYTHEME);
		intent.putExtra(Constants.ACTION_TYPE_STRING, Constants.CHANGE_THEME);
		intent.putExtra(Constants.PKGNAME_STRING, context.getPackageName());
		context.sendBroadcast(intent);
	}

	public static void sendStartThemesPanelBroadcast(Context context) {
		Intent intent = new Intent(Constants.ACTION_START_MY_THEMES);
		context.sendBroadcast(intent);
	}
	
	public static void sendInactiveApplyThemeFlagBroadcast(Context context) {
		Intent intent = new Intent(Constants.ACTION_INACTIVE_APPLY_THEME_FLAG);
		intent.putExtra(Constants.PKGNAME_STRING, context.getPackageName());
		context.sendBroadcast(intent);
	}

	public static void uninstall(Context context) {
		Uri packageURI = Uri.parse("package:" + context.getPackageName());
		Intent uninstallIntent = new Intent(Intent.ACTION_DELETE, packageURI);
		context.startActivity(uninstallIntent);
	}
	
	public static boolean isEverUsed(Context context){
		SharedPreferences sp = context.getSharedPreferences(NAME_THEME,
				Context.MODE_PRIVATE);
		return sp.getBoolean(KEY_EVER_USED, false);
	}
	
	public static void setEverUsed(Context context){
		SharedPreferences sp = context.getSharedPreferences(NAME_THEME,
				Context.MODE_PRIVATE);
		Editor editor = sp.edit();
		editor.putBoolean(KEY_EVER_USED, true);
		editor.commit();
	}
	
	public static void gotoKTOlleh_Market(Context aContext)
	{
		Intent intent = new Intent("android.intent.action.VIEW");

		intent.setType("vnd.kt.olleh.storefront/detail.kt.olleh.storefront" );

		intent.putExtra( "CONTENT_TYPE", "APPLICATION" );

		intent.putExtra("P_TYPE", "c"); 

		intent.putExtra("P_ID", "51200007006933"); 

		intent.putExtra("N_ID", "A002004"); 

		intent.putExtra("IS_ADULT", ""); 

		intent.putExtra("CAT_TYPE", ""); 

		try {
			aContext.startActivity( intent);
		} catch (ActivityNotFoundException e) {
			
			Toast.makeText(aContext, "Not found Olleh Market!", Toast.LENGTH_LONG).show();
			e.printStackTrace();
		}
		

	}
	
	/*
	 * 跳转至 韩国OZ PID
	 * 
	 */
	public static void gotoOZPID(Context aContext)
	{
		Intent intent = new Intent();
		intent.setClassName("android.lgt.appstore",
				"android.lgt.appstore.Store");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		intent.putExtra("payload", "PID=Q04010054489");
		
		try {
			aContext.startActivity( intent);
		} catch (ActivityNotFoundException e) {
			
			Toast.makeText(aContext, "Not found OZPID!", Toast.LENGTH_LONG).show();
			e.printStackTrace();
		}
	}
	
	
	/*
	 * 跳转至韩国TS客户端 
	 * 
	 */
	
	public static void gotoKO_TS(Context aContext)
	{
		String marketuriString = "tstore://PRODUCT_VIEW/0000255922/0";
		Intent EMarketintent = new Intent(Intent.ACTION_VIEW, Uri.parse(marketuriString)); 

		EMarketintent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		try {
			aContext.startActivity(EMarketintent);
		} catch (ActivityNotFoundException e) {
			String link = "tstore://PRODUCT_VIEW/0000255922/0";
			Uri browserUri = Uri.parse(link);
			Intent browserIntent = new Intent(Intent.ACTION_VIEW, browserUri);
			browserIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			try {
				aContext.startActivity(browserIntent);
			} catch (ActivityNotFoundException e2) {
	
				Toast.makeText(aContext, "Not found TS!", Toast.LENGTH_LONG).show();
				e2.printStackTrace();
			}
		} catch (Exception e3) {
			Toast.makeText(aContext, "Not found TS!", Toast.LENGTH_LONG).show();
			e3.printStackTrace();
		}
	}
}
