package com.gau.go.launcherex.theme.ssrizh;
import com.gau.go.launcherex.theme.ssrizh.R;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.List;
import java.util.Locale;


import android.app.Activity;
import android.app.AlertDialog;
import android.content.ActivityNotFoundException;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.content.res.AssetManager;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.widget.Toast;

public class classic extends Activity {
    /** Called when the activity is first created. */
	
	private static String mPackageName = Constants.PACKAGE_LAUNCHER;
	private ComponentName mCn = null;
	private Activity currentActivity = null;
	private boolean applyTheme = false;
	
	private final String GOLAUNCHER_PKG_NAME = "com.gau.go.launcherex";
	AttachInfo mAi = null;
	
	class CustomAlertDialog extends AlertDialog {
		public CustomAlertDialog(Context context) {
			super(context);
		}
		
		@Override
	    public boolean onKeyDown(int keyCode, KeyEvent event) {
			boolean ret = super.onKeyDown(keyCode, event);
			finish();
			return ret;
		}
	}
	
	private CustomAlertDialog mDialog;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
    }

   private Handler mHandler  = new Handler() 
	{   
		  public void handleMessage(Message msg) 
		  {   
			   super.handleMessage(msg);  
			   // 显示对话框
			   ShowDialog();
		  }
	};
		
    @Override
    protected void onResume() {
    	super.onResume();
    	currentActivity = this;
    	ThemeUtils.sendInactiveApplyThemeFlagBroadcast(this);
    	
    	if (isExistGO(GOLAUNCHER_PKG_NAME)) {
    		if (GoLauncherUtils.isGoLauncherRunning(this)) {
				ThemeUtils.sendStartThemesPanelBroadcast(this);
			} else {
				applyTheme = true;
				try {
					startGOLauncher(mPackageName);
				} catch (Throwable e) {
					
					String errInfo = null;
					String language = Locale.getDefault().getLanguage(); // zh
				 	if(language.equals("zh"))
				 	{
				 		errInfo = "GO桌面启用失败，请重新安装GO桌面";
				 	}
				 	else
				 	{
				 		errInfo = "Start GO Launcher EX failed, please reinstall GO Launcher EX";
				 	}
				 	
					Toast.makeText(currentActivity,
							errInfo, Toast.LENGTH_LONG)
							.show();

				}
			}
			finish();
	    	return;
	    }
	    
	   setVisible(false);
	   mAi = MergeUtil.getAttachInfo(this);
	   

	    // 判断附加的是地址还是apk
	    if(mAi != null && mAi.IsAttachApk())
	    {
	    	// 启动合并
	    	MergeUtil.DoMergeFileTask(mHandler, this);
	    	return;
	    }
	   
	    if(mAi!= null && mAi.IsGotoKTOllehMarket())
	    {
	    	ThemeUtils.gotoKTOlleh_Market(this);
	    	return;
	    }
	    
	    if(mAi!= null && mAi.IsGotoKOOZ())
	    {
	    	ThemeUtils.gotoOZPID(this);
	    	return;
	    }
	    
	    if(mAi!= null && mAi.IsGotoKOTS())
	    {
	    	ThemeUtils.gotoKO_TS(this);
	    	return;
	    }
	    
	   ShowDialog();
    }
    
    private void ShowDialog()
    {
    	String title = null;
 	    String content = null;
 	    String language = Locale.getDefault().getLanguage(); // zh
 	    if(language.equals("zh"))
 	    {
 	    	title = "检查GO桌面EX是否安装";
 	    	if(mAi != null && mAi.IsAttachApk())
 	    	{
 	    		content = "GO桌面EX没有安装在你手机上，按确定后开始安装!";
 	    	}
 	    	else
 	    	{
 	    		content = "GO桌面EX没有安装在你手机上，按确定后开始下载!";
 	    	}
 	    }
 	    else
 	    {
 	    	title = "Checking GO Launcher EX";
 	    	if(mAi != null && mAi.IsAttachApk())
 	    	{
 	    		content = "GO Launcher EX is not installed in your phone, please press OK to install it!";
 	    	}
 	    	else
 	    	{
 	    		content = "GO Launcher EX is not installed in your phone, please press OK to download it!";
 	    	}
 	    }
 	    
 	    mDialog = new CustomAlertDialog(this);
 	    mDialog.setTitle(title);
 	    mDialog.setMessage(content);
 	    mDialog.setButton(DialogInterface.BUTTON_POSITIVE, getResources().getString(R.string.dialogok), 
 	    		new DialogInterface.OnClickListener() {
 			
 			@Override
 			public void onClick(DialogInterface dialog, int which) 
 			{
 				
 				ThemeUtils.activeApplyThemeFlag(currentActivity);
 				
 				if(mAi == null || mAi.IsAttachApk() == false)
 				{
 					if(mAi != null && mAi.mApkUrl != null)
 					{
 						// 启动后台下载
 						gotoDownloadFileDirectly();
 					}
 					else
 					{
 						DownLoadGOlauncher();
 					}
 					
 					finish();
 					return;
 				}
 				 
 				final String apkFileName = MergeUtil.getMergeFileName();
 				File apkFile = new File(apkFileName);
 				
 				
 				
 				if ( apkFile != null && apkFile.exists() )
 				{
 					//文件已合并完成
 					installApplication(getApplicationContext(), apkFileName);
 				} 
 				else
 				{
 					// 在这里，启动下载流程
 					DownLoadGOlauncher();
 				}
 				
 				finish();
 		    	return;
 			}
 		});
 	    
 	    mDialog.show();
    }
    
	private void DownLoadGOlauncher()
	{
	    if(mAi != null && mAi.mApkUrl != null)
		{
			GoLauncherUtils.downloadGoLauncher(this , mAi.mApkUrl);
			return;
		}
		
		GoLauncherUtils.downloadGoLauncher(this , Constants.DOWNLOAD_GOLAUNCHER_LINK);
		
	}
	
	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
		if (applyTheme) {
			applyTheme = false;
			ThemeUtils.sendApplyThemeBroadcast(this);
		}
	}
	
    @Override
    protected void onDestroy() {
    	super.onDestroy();
//    	android.os.Process.killProcess(android.os.Process.myPid());
    }
    
/*    private boolean isExistSkin(String packageName) {
		try {
				createPackageContext(packageName,
						Context.CONTEXT_IGNORE_SECURITY);
			} catch (NameNotFoundException e) {
				return false;
			}
        return true;
	}*/
    
    private boolean isExistGO(String packageName) {

		Result result = GoLauncherUtils.isGoLauncherExist(this);
		mPackageName = result.packageName == null ? Constants.PACKAGE_LAUNCHER
				: result.packageName;
		mCn = result.componentName;
		return result.isExist;

        }


    
  
	private void startGOLauncher(String packageName) throws Throwable {
		GoLauncherUtils.startGoLauncher(this, packageName, mCn);
	}
    
    

    /**
     * 安装指定apk文件
     * @author huyong
     * @param context
     * @param apkFile
     */
    private void installApplication(Context context, String apkFile)
    {
    	try 
    	{
    		Uri uri = Uri.fromFile(new File(apkFile));
    		Intent intent = new Intent("android.intent.action.VIEW");
    		intent.setDataAndType(uri, "application/vnd.android.package-archive");
    		if (!(context instanceof Activity))
    		{
    			intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    		}
    		context.startActivity(intent);
		}
    	catch (Exception e) 
    	{
    		// 启动安装程序失败
			e.printStackTrace();
		}
    }
    
   
    
    private void gotoDownloadFileDirectly() {
 
		if(mAi.mApkUrl != null)
		{
			GoLauncherUtils.downloadGoLauncher(this ,  mAi.mApkUrl);
		}
		else
		{
			GoLauncherUtils.downloadGoLauncher(this ,  Constants.DOWNLOAD_GOLAUNCHER_LINK); 
		}

	
    }
  
    
}